Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/SCRIPTS/build_static
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/SCRIPTS/build_static	(revision 1249)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/SCRIPTS/build_static	(revision 1296)
@@ -7,7 +7,7 @@
 echo get TES albedo from PDS
 echo 1/2
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-tes-special-v1/global_albedo_8ppd.img . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-tes-special-v1/global_albedo_8ppd.img . > /dev/null 2>&1
 echo 2/2
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-tes-special-v1/global_albedo_8ppd.lbl . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-tes-special-v1/global_albedo_8ppd.lbl . > /dev/null 2>&1
 ls -l ./ | grep global_albedo*
 echo building... please wait
@@ -33,7 +33,7 @@
 echo get MOLA 32 topography from PDS ... this could be long
 echo 1/2
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg032/megt90n000fb.img . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg032/megt90n000fb.img . > /dev/null 2>&1
 echo 2/2
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg032/megt90n000fb.lbl . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg032/megt90n000fb.lbl . > /dev/null 2>&1
 ls -l ./ | grep megt*
 echo building... please wait
@@ -50,19 +50,19 @@
 ls -l ./ | grep megt*
 echo 1/8
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt90n000gb.img . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt90n000gb.img . > /dev/null 2>&1
 echo 2/8
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt90n000gb.lbl . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt90n000gb.lbl . > /dev/null 2>&1
 echo 3/8
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt90n180gb.img . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt90n180gb.img . > /dev/null 2>&1
 echo 4/8
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt90n180gb.lbl . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt90n180gb.lbl . > /dev/null 2>&1
 echo 5/8
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt00n000gb.img . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt00n000gb.img . > /dev/null 2>&1
 echo 6/8
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt00n000gb.lbl . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt00n000gb.lbl . > /dev/null 2>&1
 echo 7/8
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt00n180gb.img . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt00n180gb.img . > /dev/null 2>&1
 echo 8/8
-wget http://pds-geosciences.wustl.edu/geo/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt00n180gb.lbl . > /dev/null 2>&1
+wget http://pds-geosciences.wustl.edu/mgs/mgs-m-mola-5-megdr-l3-v1/mgsl_300x/meg064/megt00n180gb.lbl . > /dev/null 2>&1
 echo building... please wait
 ./mola_buildNE.m  
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WPS/metgrid/src/process_domain_module.F90
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WPS/metgrid/src/process_domain_module.F90	(revision 1249)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WPS/metgrid/src/process_domain_module.F90	(revision 1296)
@@ -562,5 +562,7 @@
       real :: met_cen_lon, met_truelat1, met_truelat2
       logical :: is_wind_grid_rel, do_gcell_interp
-      integer, pointer, dimension(:) :: u_levels, v_levels
+      !! this is a fix for the following problem
+      !! "A pointer passed to DEALLOCATE points to an array that cannot be deallocated"
+      integer, pointer, dimension(:) :: u_levels => NULL(), v_levels => NULL()
       real, pointer, dimension(:,:) :: slab, data_count, halo_slab
       real, pointer, dimension(:,:,:) :: real_array
@@ -1670,4 +1672,8 @@
       call list_destroy(temp_levels)
       deallocate(headers)
+
+      !! this is a fix for the following problem
+      !! "A pointer passed to DEALLOCATE points to an array that cannot be deallocated"
+      print*,'done'
 
    end subroutine get_bottom_top_dim