Index: trunk/LMDZ.GENERIC/deftank/edu/INIT/planet_start
===================================================================
--- trunk/LMDZ.GENERIC/deftank/edu/INIT/planet_start	(revision 1323)
+++ trunk/LMDZ.GENERIC/deftank/edu/INIT/planet_start	(revision 1330)
@@ -7,4 +7,8 @@
 g                    !! *  
 9.81                 !! <-- Acceleration gravite (m/s2)
+mugaz                !! *
+28.0                 !! <-- Masse molaire atmosphérique (g/mol)
+rcp                  !! *
+0.286                !! <-- Rapport r/cp (massiques)
 daysec               !! *
 86400                !! <-- Duree du jour (s)
@@ -20,5 +24,5 @@
 0.                   !! <-- Date periastre (jours depuis printemps)
 obliquit             !! *
-25.0                 !! <-- Obliquite (degres)
+23.9                 !! <-- Obliquite (degres)
                   
 none              
Index: trunk/LMDZ.GENERIC/deftank/edu/INIT/planet_start.mars
===================================================================
--- trunk/LMDZ.GENERIC/deftank/edu/INIT/planet_start.mars	(revision 1330)
+++ trunk/LMDZ.GENERIC/deftank/edu/INIT/planet_start.mars	(revision 1330)
@@ -0,0 +1,41 @@
+0                    !! *
+y                    !! *
+1.e3                 !! <-- Pression de surface (Pa)
+1.e20                !! *
+rad                  !! *
+3.4e6                !! <-- Rayon planetaire (m)
+g                    !! *  
+3.72                 !! <-- Acceleration gravite (m/s2)
+mugaz                !! *
+43.5                 !! <-- Masse molaire atmosphérique (g/mol)
+rcp                  !! *
+0.227                !! <-- Rapport r/cp (massiques)
+daysec               !! *
+88775                !! <-- Duree du jour (s)
+omeg                 !! *
+-9999.               !! *
+year_day             !! *
+669                  !! <-- Duree d'une annee (jours)
+periastr             !! *
+1.38                 !! <-- Distance mini etoile-planete (UA)
+apoastr              !! *
+1.67                 !! <-- Distance maxi etoile-planete (UA)
+peri_day             !! *
+0.                   !! <-- Date periastre (jours depuis printemps)
+obliquit             !! *
+25.2                 !! <-- Obliquite (degres)
+                 
+none              
+0.25                 !! <-- Albedo (sol nu, sans dimension)
+500.                 !! <-- Inertie thermique (J/m-2/K-1/s-0.5)
+6695                 !! *
+flat                 !! *
+y                    !! *
+-9999.               !! *
+isotherm             !! *
+300.                 !! <-- Temperature initiale (K)
+emis                 !! *
+0.95                 !! <-- Emissivite de la surface
+slab_ocean_0         !! *
+therm_ini_s          !! *
+
Index: trunk/LMDZ.GENERIC/deftank/edu/RUN/def_benj_earth/callphys.def
===================================================================
--- trunk/LMDZ.GENERIC/deftank/edu/RUN/def_benj_earth/callphys.def	(revision 1323)
+++ trunk/LMDZ.GENERIC/deftank/edu/RUN/def_benj_earth/callphys.def	(revision 1330)
@@ -38,20 +38,21 @@
 corrk      = .true.
 # Include continuum absorption in radiative transfer (note CO2 is treated separately) ?
-continuum  = .true.
+continuum  = .false.
 # folder in which correlated-k data is stored ?
- corrkdir    = earth
+# corrkdir    = earth
 # corrkdir   = N2CO2poor_H2Ovar
 # corrkdir   = megaCO2
-# corrkdir   = null
+ corrkdir   = null
 # call visible gaseous absorption in radiative transfer ?
-callgasvis = .true.
+callgasvis = .false.
 # Include Rayleigh scattering in the visible ?
-rayleigh   = .true.
+rayleigh   = .false.
 # Uniform absorption coefficient in radiative transfer?
-graybody   = .false.
+graybody   = .true.
 # Constant absorption coefficient in visible 
 #      (in m^2/kg; only if graybody=true):
 #      tau_surf= kappa*P/g
-kappa_VI = 5.e-7
+#kappa_VI = 5.e-7
+kappa_VI = 5.e-20
 # Constant absorption coefficient in IR
 #      (in m^2/kg; only if graybody=true):
@@ -79,4 +80,5 @@
 # Force specific heat capacity and molecular mass values
 force_cpp      = .true.
+force_cpp      = .false.
 # Specific heat capacity in J K-1 kg-1 [only used if force_cpp = T]
 cpp            = 1039.918
@@ -158,5 +160,5 @@
 
 # To not call abort when temperature is outside boundaries:
-strictboundcorrk = .false.
+strictboundcorrk = .true.
 
 
Index: trunk/LMDZ.GENERIC/deftank/edu/RUN/etu.def
===================================================================
--- trunk/LMDZ.GENERIC/deftank/edu/RUN/etu.def	(revision 1323)
+++ trunk/LMDZ.GENERIC/deftank/edu/RUN/etu.def	(revision 1330)
@@ -1,4 +1,7 @@
 # Nombre de jours d'intégration                
-nday = 730
+nday = 1825
+#nday = 3650
+#nday = 7300
+#nday = 14600
 
 # Nombre de pas d'intégration dynamique par jour
@@ -11,13 +14,6 @@
 iphysiq = 1
 
-##########
-# mode simple "gris" (coefficient d'absorption constant selon lambda)
-graybody  = .true.
-continuum = .false.
-corrkdir  = null
-# coefficient d'absorption IR et VIS en m2/kg [--> kappa ~ tau_surf*g/P]
+# Coefficient d'absorption IR en m2/kg [--> kappa ~ tau_surf*g/P]
 kappa_IR = 5.e-5
-kappa_VI = 5.e-6
-##########
 
 
Index: trunk/LMDZ.GENERIC/deftank/edu/atlas.exe
===================================================================
--- trunk/LMDZ.GENERIC/deftank/edu/atlas.exe	(revision 1323)
+++ trunk/LMDZ.GENERIC/deftank/edu/atlas.exe	(revision 1330)
@@ -9,12 +9,17 @@
 #########################################################################
 
+# arguments
+from optparse import OptionParser ### TBR by argparse
+parser = OptionParser()
+(opt,args) = parser.parse_args()
+if len(args) == 0: args = "resultat.nc"
+
 # OK. then the actual plotting commands.
 # -- people should be encouraged to use the command line pp.py too
-
 from ppclass import pp
 
-fi="resultat.nc"
+fi=args
 
-t = pp(var="tsurf",file =fi,x="-180,180",y=[-80,-60,-20,0],superpose=True,quiet=True,ylabel=r'surface temperature ($^{\circ}$C)').get()-273.15
+t = pp(var="tsurf",file=fi,x="-180,180",y=[-80,-60,-20,0],superpose=True,quiet=True,ylabel=r'surface temperature ($^{\circ}$C)').get()-273.15
 t.plot()
 
Index: trunk/LMDZ.GENERIC/deftank/edu/run.exe
===================================================================
--- trunk/LMDZ.GENERIC/deftank/edu/run.exe	(revision 1323)
+++ trunk/LMDZ.GENERIC/deftank/edu/run.exe	(revision 1330)
@@ -14,6 +14,8 @@
 b1=3 # recompile with full if you changed this
 b2=2 # recompile with full if you changed this
+b1=1 # recompile with full if you changed this
+b2=1 # recompile with full if you changed this
 
-echo "*** COMPILATION GCM ***"
+echo "*** COMPILATION GCM *** ne pas interrompre ***"
 cd $wheresource/LMDZ.COMMON ; \rm gcm.e
 makelmdz -cpp NODYN -d $nx"x"$ny"x"$nz -b $b1"x"$b2 -t $tr -s 1 -p generic -arch gfortran gcm > logcompilegcm 2> logcompilegcm
@@ -22,5 +24,5 @@
 fi
 
-echo "*** COMPILATION NEWSTART ***"
+echo "*** COMPILATION NEWSTART *** ne pas interrompre ***"
 cd $wheresource/LMDZ.GENERIC ; \rm newstart.e
 makegcm_gfortran_local -d $nx"x"$ny"x"$nz -debug newstart > logcompilerestart 2> logcompilerestart
@@ -39,4 +41,6 @@
 cd $thisfolder/RUN ; \rm resultat.nc > /dev/null 2> /dev/null
 time gcm.e | tee log_gcm | grep "Ls ="
+#time gcm.e > /dev/null 2> /dev/null
+#time gcm.e #| grep "WRITE"
 mv diagfi.nc ../resultat.nc
 